﻿// BenLincoln.TheLostWorlds.CDBigFile
// Copyright 2006-2019 Ben Lincoln
// https://www.thelostworlds.net/
//

// This file is part of BenLincoln.TheLostWorlds.CDBigFile.

// BenLincoln.TheLostWorlds.CDBigFile is free software: you can redistribute it and/or modify
// it under the terms of version 3 of the GNU General Public License as published by
// the Free Software Foundation.

// BenLincoln.TheLostWorlds.CDBigFile is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with BenLincoln.TheLostWorlds.CDBigFile (in the file LICENSE.txt).  
// If not, see <http://www.gnu.org/licenses/>.

using System;
using System.Collections.Generic;
using System.Text;
using BF = BenLincoln.TheLostWorlds.CDBigFile;

namespace BenLincoln.TheLostWorlds.CDBigFile
{
    public class Gex2PrototypeFileIndex : BF.FileIndex
    {
        // Each entry is 20 bytes
        // Hash (4 bytes)
        // Length (4 bytes)
        // Offset in bigfile (4 bytes)
        // Unknown 1 (checksum?) (4 bytes)
        // First four bytes of file (4 bytes)

        public Gex2PrototypeFileIndex(string name, BF.BigFile parentBigFile, BF.Index parentIndex, long offset)
            : base(name, parentBigFile, parentIndex, offset)
        {
            mEntryLength = 5;
            mNameHashPosition = 0;
            mLengthPosition = 1;
            mOffsetPosition = 2;
        }
    }
}
